"""launch apps and close them until a crash"""
from testtools.content import text_content

from lrt import _run_command
from lrt import LRTTestCase
from lrt.gestures import (
    click_random_location,
    swipe,
    SwipeDirection,
)

import time


class OpenCloseTests(LRTTestCase):

    def test_open_close(self):
        app_list = [
            'mediaplayer-app',
            'dialer-app',
            'ubuntu-system-settings',
            'webbrowser-app',
            'messaging-app',
            'address-book-app',
        ]

        def launch_apps():
            for app in app_list:
                _run_command('ubuntu-app-launch {} &'.format(app))
                time.sleep(5)  # wait for app to launch

        self.launch_apps()

        self.addDetail(
            'test_name',
            text_content('OpenClose')
        )

        while 1:
            swipe(SwipeDirection(4))
            click_random_location()
            swipe(SwipeDirection(4))
            swipe(SwipeDirection(3))
            swipe(SwipeDirection(3))
            swipe(SwipeDirection(3))
            swipe(SwipeDirection(3))
            swipe(SwipeDirection(3))
            swipe(SwipeDirection(4))
            swipe(SwipeDirection(3))
            swipe(SwipeDirection(3))
            swipe(SwipeDirection(3))
            swipe(SwipeDirection(3))
            swipe(SwipeDirection(3))
            swipe(SwipeDirection(3))
            self.check_for_crash()
            self.launch_apps()
