"""launch apps and swipe until crash"""
import random
import time

from evdev import ecodes, uinput
from testtools.content import text_content

from lrt import LRTTestCase
from lrt.gestures import (
    click_random_location,
    swipe,
    SwipeDirection,
    unlock_ui
)


def tap_button(key):
    """Tap a button using uinput

    :param key: the ecode

    >>>tap_button(e.KEY_POWER)  # taps the power button
    """
    with uinput.UInput() as ui:
        ui.write(ecodes.EV_KEY, key, 1)
        ui.write(ecodes.EV_KEY, key, 0)
        ui.syn()


class PowerTests(LRTTestCase):

    def test_power(self):

        self.addDetail(
            'test_name',
            text_content('Power')
        )

        while 1:
            rand = random.random()
            if rand >= 0.5:
                click_random_location()
            elif rand <= 0.2:
                rand_button = random.random()
                if rand_button <= 0.7:  # suspend phone
                    tap_button(ecodes.KEY_POWER)
                    self.check_for_crash()
                    time.sleep(1)
                    tap_button(ecodes.KEY_POWER)
                    unlock_ui()
                elif rand_button >= .85:
                    for i in range(1, random.randint(1, 10)):
                        tap_button(ecodes.KEY_VOLUMEUP)
                else:
                    for i in range(1, random.randint(1, 10)):
                        tap_button(ecodes.KEY_VOLUMEDOWN)

            else:
                swipe(SwipeDirection.get_random_direction())

            self.check_for_crash()
