"""launch apps and swipe until crash"""
from testtools.content import text_content

from lrt import _run_command
from lrt import LRTTestCase
from lrt.gestures import (
    click_random_location,
    swipe,
    SwipeDirection,
)

import time


class SwitchTests(LRTTestCase):

    def test_switch(self):
        app_list = [
            'mediaplayer-app',
            'dialer-app',
            'ubuntu-system-settings',
            'webbrowser-app',
            'messaging-app',
            'address-book-app',
        ]
        for app in app_list:
            _run_command('ubuntu-app-launch {} &'.format(app))
            time.sleep(5)

        self.addDetail(
            'test_name',
            text_content('Switch')
        )

        while 1:
            swipe(SwipeDirection(4))
            click_random_location()
            self.check_for_crash()
