#!/bin/bash
# this starts the lrt tests 
set -e
set -x

if [ -z $1 ]; then
    echo 'you must specify the test to run, example: lrt.test_random_gestures'
    exit 1
fi
TEST_NAME=$1

#turn on the screen
powerd-cli display on bright &

python3 -m subunit.run $TEST_NAME > ~/result.subunit || true
sudo chmod a+rw ~/result.subunit

# disable flight mode
sudo /usr/share/urfkill/scripts/flight-mode 0

# wait for wifi a bit
sleep 10


#enable wifi, the test can disable it
ping -c2 launchpad.net || nmcli nm wifi on


list_crashes=$(sudo ls /var/crash)

if [ -z "$list_crashes" ]; then
    echo no crash files found
    exit 1
fi

#wait for crash file to be ready
ls /var/crash | grep crash | while read line; do
    while [ $(stat -c "%a %n" /var/crash/$line | cut -d ' ' -f1) -le 0 ] ; do
        sleep 5
        echo "waiting for crash file to become ready" to upload
    done
done


sudo /usr/share/apport/whoopsie-upload-all || true  # this fails a lot

sudo tail /var/log/upstart/whoopsie.log || true

# I can't use launchpadlib from python3. so I use a python2 app
#ls /var/crash | grep crash | while read line; do
#    echo "Summary:" > crash.report
#    echo "Crash file $line was found" >> crash.report
#    echo " " >> crash.report
#    echo "Steps to reproduce:" >> crash.report
#    echo "1. Run lrt test in lp:lrt" >> crash.report 
#    echo " " >> crash.report
#    echo "Expected result:" >> crash.report 
#    echo "No crashes happen" >> crash.report
#    echo " " >> crash.report
#    echo "Actual result:" >> crash.report
#    echo "A crash happened" >> crash.report
#    echo " " >> crash.report
#    echo "System info:" >> crash.report
#    tail -n6  /etc/system-image/channel.ini >> crash.report
#    echo "Device=$(getprop ro.hardware)" >> crash.report
#    sudo ./auto_bug.py --description="$(cat crash.report)" --attachment="/var/crash/$line" --title="lrt test found crash file $line" || true

#done

project=$(echo $TEST_NAME| cut -d '.' -f1)
name=$(echo $TEST_NAME| cut -d '.' -f2 | sed 's/test_//')

python3 /home/phablet/autopilot/lrt/helpers/create_json_for_nfss.py -f /home/phablet/result.subunit

python3 /home/phablet/autopilot/lrt/helpers/create_json_for_nfss.py -f /home/phablet/result.subunit | python3 /home/phablet/insert_lrt_in_nfss.py $project $name || true

